controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use yii\data\SqlDataProvider;
use yii\data\ActiveDataProvider;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use app\models\Etapa;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }

    /**
     * Login action.
     *
     * @return Response|string
     */
    public function actionLogin()
    {
        if (!Yii::$app->user->isGuest) {
            return $this->goHome();
        }

        $model = new LoginForm();
        if ($model->load(Yii::$app->request->post()) && $model->login()) {
            return $this->goBack();
        }

        $model->password = '';
        return $this->render('login', [
            'model' => $model,
        ]);
    }

    /**
     * Logout action.
     *
     * @return Response
     */
    public function actionLogout()
    {
        Yii::$app->user->logout();

        return $this->goHome();
    }

    /**
     * Displays contact page.
     *
     * @return Response|string
     */
    public function actionContact()
    {
        $model = new ContactForm();
        if ($model->load(Yii::$app->request->post()) && $model->contact(Yii::$app->params['adminEmail'])) {
            Yii::$app->session->setFlash('contactFormSubmitted');

            return $this->refresh();
        }
        return $this->render('contact', [
            'model' => $model,
        ]);
    }

    /**
     * Displays about page.
     *
     * @return string
     */
    public function actionAbout()
    {
        return $this->render('about');
    }
    
     
    //QUERY 1 DAO
   public function actionConsulta1(){
        $dataProvider = new SqlDataProvider(['sql'=>'SELECT DISTINCT COUNT(dorsal) as total FROM ciclista'

        ]);
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['total'],
            "titulo"=>"Consulta 1 con DAO",
            "enunciado"=>" Número de ciclistas que hay",
            "sql"=>"SELECT DISTINCT COUNT(dorsal) as total FROM ciclista",
        ]);
     }
     /*Definicion de la consulta 1
      * Utilizamos la funcion de totales count para que nos sume todos los dorsales que hay en la tabla de ciclista 
      */
     //QUERY 1 DAO
    public function actionConsulta1a(){
        $dataProvider = new ActiveDataProvider([
         'query'=> Ciclista::find()
                ->select("COUNT(dorsal) as total")
                ->distinct(),
        ]);
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['total'],
            "titulo"=>"Consulta 1 con Action Record",
            "enunciado"=>"Número de ciclistas que hay",
            "sql"=>"SELECT DISTINCT COUNT(dorsal) as total FROM ciclista",
        ]);
}
    
      
    //QUERY 2 DAO
    public function actionConsulta2(){
        
        $dataProvider = new SqlDataProvider([
            
            'sql'=>'SELECT DISTINCT COUNT(dorsal) as totalbanesto FROM ciclista WHERE nomequipo = "Banesto"',
        ]);
        
        return $this ->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['totalbanesto'],
            "titulo"=>"Consulta 2 con DAO",
            "enunciado"=>"Número de ciclistas que hay del equipo Banesto",
            "sql"=>'SELECT DISTINCT COUNT(dorsal)as totalbanesto FROM ciclista WHERE nomequipo = "Banesto"',
        ]);
    }
      /*Definicion consulta 2
      * Con el operador Count hacemos una suma de todos los dorsales aplicando la restricion de que estos dorsales sean 
      * ciclistas del equipo de banesto y le añadimos el alias previamente definido en el modelo.
      */
        
    //QUERY 2 ORM
    public function actionConsulta2a(){
        $dataProvider = new ActiveDataProvider([
         'query'=> Ciclista::find()
                ->select("COUNT(dorsal) as totalbanesto")
                ->distinct()
                ->where('nomequipo = "banesto"'),
        ]);
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['totalbanesto'],
            "titulo"=>"Consulta 2 con Action Record",
            "enunciado"=>"Número de ciclistas que hay del equipo Banesto",
            "sql"=>"SELECT COUNT(dorsal) as totalbanesto FROM ciclista WHERE nomequipo = 'banesto'",
        ]);
    }
    
       
    //QUERY 3 DAO
    public function actionConsulta3(){
        
        $dataProvider = new SqlDataProvider([
            
            'sql'=>'SELECT DISTINCT AVG (edad) as mediaedad FROM ciclista',
        ]);
        
        return $this ->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['mediaedad'],
            "titulo"=>"Consulta 3 con DAO",
            "enunciado"=>"Edad media de los ciclistas",
            "sql"=>"SELECT DISTINCT AVG (edad) as mediaedad FROM ciclista",
        ]);
    }
      /*Definicion Consulta 3
      * Utilizamos la funcion avg indicando el campo del que queremos hacer la media de la tabla ciclistas y le ponemos un alias al resultado de la media
      * 
      */
           
    //QUERY 3 ORM
    public function actionConsulta3a(){
        $dataProvider = new ActiveDataProvider([
            'query'=> Ciclista::find()
                   ->select("AVG(edad) as mediaedad")
                   ->distinct(),
                   
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['mediaedad'],
            "titulo"=>"Consulta 3 con Active Record",
            "enunciado"=>"Edad media de los ciclistas",
            "sql"=>"SELECT DISTINCT AVG (edad) as mediaedad FROM ciclista",
        ]);
    }
    //QUERY 4 DAO
     public function actionConsulta4(){
        
        $dataProvider = new SqlDataProvider([
            
            'sql'=>'SELECT DISTINCT AVG (edad) as mediaedadbanesto FROM ciclista WHERE nomequipo = "Banesto"',
        ]);
        
        return $this ->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['mediaedadbanesto'],
            "titulo"=>"Consulta 4 con DAO",
            "enunciado"=>"La edad media de los ciclistas del equipo Banesto",
            "sql"=>'"SELECT DISTINCT AVG (edad) as mediaedadbanesto FROM ciclista WHERE nomequipo = "Banesto"',
        ]);
    }
      /*Definicion consulta 4
      * Con la funcion avg hacemos la media de la edad llamandola mediaedadbanesto con un alias y en el where aplicamos la resticion de que pertenezcan al equipo banesto
      * 
      */
    //QUERY 4 ORM
    public function actionConsulta4a(){
        $dataProvider = new ActiveDataProvider([
            'query'=> Ciclista::find()
                   ->select("AVG(edad) as mediaedadbanesto")
                   ->distinct()
                   ->where("nomequipo = 'Banesto'"),
                   
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['mediaedadbanesto'],
            "titulo"=>"Consulta 4 con Active Record",
            "enunciado"=>"La edad media de los ciclistas del equipo Banesto",
            "sql"=>"SELECT DISTINCT AVG(edad) as mediaedadbanesto FROM ciclista",
        ]);
    }
    
     //QUERY 5 DAO
    public function actionConsulta5(){
        
        $dataProvider = new SqlDataProvider([
            
            'sql'=>'SELECT AVG (edad) as mediaedadequipos, nomequipo FROM  ciclista GROUP BY nomequipo',
        ]);
        
        return $this ->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['mediaedadequipos','nomequipo'],
            "titulo"=>"Consulta 5 con DAO",
            "enunciado"=>"La edad media de los ciclistas por cada equipo",
            "sql"=>"SELECT AVG (edad) as mediaedadequipos FROM ciclista Group BY nomequipo",
        ]);
    }
    /*Definicion consulta 5
     * 
     * Con el avg hacemos la media de edad de los equipos y los agrupamos por el nombre de equipo
     * 
     */
           
    //QUERY 5 ORM
    public function actionConsulta5a(){
        $dataProvider = new ActiveDataProvider([
            'query'=> Ciclista::find()
                ->select("AVG(edad) as mediaedadequipos, nomequipo")
                ->groupBy("nomequipo"),
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['mediaedadequipos','nomequipo'],
            "titulo"=>"Consulta 5 con Active Record",
            "enunciado"=>"La edad media de los ciclistas por cada equipo",

views/site/about.php
<?php

/* @var $this yii\web\View */

use yii\helpers\Html;

$this->title = 'About';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-about">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        This is the About page. You may modify the following file to customize its content:
    </p>

    <code><?= __FILE__ ?></code>
</div>

views/site/contact.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\ContactForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;
use yii\captcha\Captcha;

$this->title = 'Contact';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-contact">
    <h1><?= Html::encode($this->title) ?></h1>

    <?php if (Yii::$app->session->hasFlash('contactFormSubmitted')): ?>

        <div class="alert alert-success">
            Thank you for contacting us. We will respond to you as soon as possible.
        </div>

        <p>
            Note that if you turn on the Yii debugger, you should be able
            to view the mail message on the mail panel of the debugger.
            <?php if (Yii::$app->mailer->useFileTransport): ?>
                Because the application is in development mode, the email is not sent but saved as
                a file under <code><?= Yii::getAlias(Yii::$app->mailer->fileTransportPath) ?></code>.
                Please configure the <code>useFileTransport</code> property of the <code>mail</code>
                application component to be false to enable email sending.
            <?php endif; ?>
        </p>

    <?php else: ?>

        <p>
            If you have business inquiries or other questions, please fill out the following form to contact us.
            Thank you.
        </p>

        <div class="row">
            <div class="col-lg-5">

                <?php $form = ActiveForm::begin(['id' => 'contact-form']); ?>

                    <?= $form->field($model, 'name')->textInput(['autofocus' => true]) ?>

                    <?= $form->field($model, 'email') ?>

                    <?= $form->field($model, 'subject') ?>

                    <?= $form->field($model, 'body')->textarea(['rows' => 6]) ?>

                    <?= $form->field($model, 'verifyCode')->widget(Captcha::className(), [
                        'template' => '<div class="row"><div class="col-lg-3">{image}</div><div class="col-lg-6">{input}</div></div>',
                    ]) ?>

                    <div class="form-group">
                        <?= Html::submitButton('Submit', ['class' => 'btn btn-primary', 'name' => 'contact-button']) ?>
                    </div>

                <?php ActiveForm::end(); ?>

            </div>
        </div>

    <?php endif; ?>
</div>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php
use yii\helpers\Html;
/* @var $this yii\web\View */

$this->title = 'Consultas de Selección 2';
?>
<div class="site-index">
    
    <div class="jumbotron text-center bg-transparent">
        <h1 class="display-4">Consultas de Selección</h1>
    </div>

    <div class="body-content">
        
        <div class="row">
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 1</h3>
                        <p>Número de ciclistas que hay</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta1a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta1'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
         <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 2</h3>
                        <p> Número de ciclistas que hay del equipo Banesto</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta2a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta2'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                  <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 3</h3>
                        <p>Edad media de los ciclistas</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta3a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta3'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 4</h3>
                        <p>La edad media de los ciclistas del equipo Banesto</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta4a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta4'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
            
                   <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 5</h3>
                        <p>La edad media de los ciclistas por cada equipo</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta5a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta5'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 6</h3>
                        <p>El número de ciclistas por equipo</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta6a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta6'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 7</h3>
                        <p>El número total de puertos</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta7a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta7'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 8</h3>
                        <p>El número total de puertos mayores de 1500</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta8a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta8'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 9</h3>
                        <p>Listar el nombre de los equipos que tengan más de 4 ciclistas</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta9a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta9'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 10</h3>
                        <p>Listar el nombre de los equipos que tengan más de 4 ciclistas cuya edad esté entre 28 y 32</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta10a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta10'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
                     <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 11</h3>
                        <p>Indícame el número de etapas que ha ganado cada uno de los ciclistas</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta11a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta11'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
            
            <div class="col-sm-6 col-md-4">
                <div class="card alturaminima">
                    <div class="card-body tarjeta">
                        <h3>Consulta 12</h3>
                        <p>Indícame el dorsal de los ciclistas que hayan ganado más de una etapa</p>
                        <p>
                            <?= Html::a('Active Record',['site/consulta12a'],['class' =>'btn btn-primary'])?>
                            <?= Html::a('DAO',['site/consulta12'],['class'=>'btn btn-warning'])?>
                        </p>
                    </div>
               </div>
        </div>
</div>
</div>
</div>

views/site/login.php
<?php

/* @var $this yii\web\View */
/* @var $form yii\bootstrap4\ActiveForm */
/* @var $model app\models\LoginForm */

use yii\bootstrap4\ActiveForm;
use yii\bootstrap4\Html;

$this->title = 'Login';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="site-login">
    <h1><?= Html::encode($this->title) ?></h1>

    <p>Please fill out the following fields to login:</p>

    <?php $form = ActiveForm::begin([
        'id' => 'login-form',
        'layout' => 'horizontal',
        'fieldConfig' => [
            'template' => "{label}\n{input}\n{error}",
            'labelOptions' => ['class' => 'col-lg-1 col-form-label mr-lg-3'],
            'inputOptions' => ['class' => 'col-lg-3 form-control'],
            'errorOptions' => ['class' => 'col-lg-7 invalid-feedback'],
        ],
    ]); ?>

        <?= $form->field($model, 'username')->textInput(['autofocus' => true]) ?>

        <?= $form->field($model, 'password')->passwordInput() ?>

        <?= $form->field($model, 'rememberMe')->checkbox([
            'template' => "<div class=\"offset-lg-1 col-lg-3 custom-control custom-checkbox\">{input} {label}</div>\n<div class=\"col-lg-8\">{error}</div>",
        ]) ?>

        <div class="form-group">
            <div class="offset-lg-1 col-lg-11">
                <?= Html::submitButton('Login', ['class' => 'btn btn-primary', 'name' => 'login-button']) ?>
            </div>
        </div>

    <?php ActiveForm::end(); ?>

    <div class="offset-lg-1" style="color:#999;">
        You may login with <strong>admin/admin</strong> or <strong>demo/demo</strong>.<br>
        To modify the username/password, please check out the code <code>app\models\User::$users</code>.
    </div>
</div>

views/site/resultado.php
<?php
use yii\grid\GridView;
?>

<div class="jumbotron">
    <h2><?=$titulo?></h2>
    
    <p class='lead'><?= $enunciado ?></p>
    <div class="well">
    <?= $sql ?>
    </div>
</div>

<?= GridView::widget([
    'dataProvider' => $resultados,
    'columns'=>$campos
]); ?>